﻿Imports System.Diagnostics
Imports System.Runtime.CompilerServices
Namespace System.Reflection

	Public Module ReflectionX
		<Extension()>
		Public Function GetAttribute(Of T As Attribute)(mmb As MemberInfo) As T
			Return DirectCast(Attribute.GetCustomAttribute(mmb, GetType(T)), T)
		End Function
		<Extension()>
		Public Function GetAttributes(Of T As Attribute)(tp As Type) As T()
			Return DirectCast(tp.GetCustomAttributes(GetType(T), True), T())
		End Function
		<DebuggerStepThrough(), Extension()>
		Public Function GetValue(prp As PropertyInfo, Obj As Object) As Object
			Return prp.GetValue(Obj, Nothing)
		End Function
		<DebuggerStepThrough(), Extension()>
		Public Sub SetValue(prp As PropertyInfo, Obj As Object, value As Object)
			prp.SetValue(Obj, value, Nothing)
		End Sub
	End Module

End Namespace
