﻿#Region "FileHeader"
#If False Then
#End If
'-- Options, Imports
#End Region 'FileHeader

Imports System.Runtime.CompilerServices

Namespace System.Collections.Generic

   Public Module FuncX


      Public Delegate Function GetChilds(Of T)(item As T) As IEnumerable

      <Extension()> _
      Public Function AllChilds(Of T)( _
            GetChilds As Func(Of T, IEnumerable), _
            Roots As IEnumerable) As IEnumerable(Of T)
         Dim Enumerate As Func(Of IEnumerable(Of T), IEnumerable(Of T)) = Nothing
         Enumerate = Function(enmbl) enmbl.Concat(enmbl.SelectMany(Function(nd) Enumerate(GetChilds(nd).Cast(Of T))))
         Return Enumerate(Roots.Cast(Of T))
      End Function

      <Extension()> _
      Public Function All(Of T)( _
            GetChilds As Func(Of T, IEnumerable), Root As T) As IEnumerable(Of T)
         'Root wird in die Enumeration hineingenommen, indem ein es enthaltendes IEnumerable(Of T) 
         'geschaffen wird, dessen Kinder ( = nur Root ) rekursiv enumeriert werden
         Return GetChilds.AllChilds(New T() {Root})
      End Function

      <Extension()> _
      Public Function AllAsList(Of T)(getChilds As GetChilds(Of T), Roots As IEnumerable) As List(Of T)
         Dim ret As New List(Of T)
         For Each child As T In Roots : ret.Add(child) : Next
         Dim i As Integer = 0
         While i < ret.Count
            For Each child As T In getChilds(ret(i)) : ret.Add(child) : Next
            i += 1
         End While
         Return ret
      End Function

      <Extension()> _
      Public Function AllChildsBFT(Of T)(getChilds As Func(Of T, IEnumerable(Of T)), Roots As IEnumerable(Of T)) As List(Of T)
         Dim ret As New List(Of T)(Roots)
         Dim i As Integer = 0
         While i < ret.Count
            ret.AddRange(getChilds(ret(i)))
            i += 1
         End While
         Return ret
      End Function

      <Extension()> _
      Public Function AllAsList(Of T)(getChilds As GetChilds(Of T), Root As T) As List(Of T)
         Return getChilds.AllAsList(New T() {Root})
      End Function

      <Extension()> _
      Public Iterator Function Enumerate(Of T As Class)(getNext As Func(Of T)) As IEnumerable(Of T)
         Do
            Dim itm = getNext()
            If itm Is Nothing Then Return
            Yield itm
         Loop
      End Function
      <Extension()>
      Public Iterator Function Enumerate(Of T As Class)(getNext As Func(Of T, T), itm As T) As IEnumerable(Of T)
         Yield itm
         Do
            itm = getNext(itm)
            If itm Is Nothing Then Return
            Yield itm
         Loop
      End Function

   End Module

End Namespace
