﻿Namespace Global.System.Data

	Public Class DatasetViewer
		Public Shared Shadows Sub Show(dts As DataSet, Optional frmOwner As IWin32Window = Nothing, Optional title As String = Nothing)
			Dim frm = New DatasetViewer With {.Text = If(title, dts.DataSetName)}
			frm.Grid.DataSource = dts
			DirectCast(frm, Form).Show(frmOwner)
		End Sub
		Public Shared Shadows Sub ShowDialog(dts As DataSet, Optional frmOwner As IWin32Window = Nothing, Optional title As String = Nothing)
			Using frm = New DatasetViewer With {.Text = If(title, dts.DataSetName)}
				frm.Grid.DataSource = dts
				DirectCast(frm, Form).ShowDialog(frmOwner)
			End Using
		End Sub
		Public Shared Shadows Sub Show(tb As DataTable, Optional frmOwner As IWin32Window = Nothing, Optional title As String = Nothing)
			Dim frm = New DatasetViewer With {.Text = If(title, tb.TableName)}
			frm.Grid.DataSource = tb
			DirectCast(frm, Form).Show(frmOwner)
		End Sub
		Public Shared Shadows Sub ShowDialog(tb As DataTable, Optional frmOwner As IWin32Window = Nothing, Optional title As String = Nothing)
			Using frm = New DatasetViewer With {.Text = If(title, tb.TableName)}
				frm.Grid.DataSource = tb
				DirectCast(frm, Form).ShowDialog(frmOwner)
			End Using
		End Sub
	End Class

End Namespace